Main Page Alphabetical List Data Structures File List Data Fields Globals

# ipa.h File Reference

## Data Structures
struct | _wmfBMP
struct | _wmfBMP_Draw_t
struct | _wmfBMP_Read_t
struct | _wmfBrush
struct | _wmfColorData
struct | _wmfDC
struct | _wmfDrawArc_t
struct | _wmfDrawLine_t
struct | _wmfDrawPixel_t
struct | _wmfDrawRectangle_t
struct | _wmfDrawText_t
struct | _wmfFlood_t
struct | _wmfFont
struct | _wmfFontData
struct | _wmfFT_CacheEntry
struct | _wmfFT_Mapping
struct | _wmfFunctionReference
struct | _wmfGS_FontData
struct | _wmfGS_FontInfo
struct | _wmfPen
struct | _wmfPolyLine_t
struct | _wmfPolyRectangle_t
struct | _wmfRGB
struct | _wmfROP_Draw_t
struct | _wmfUserData_t
struct | _wmfXML_FontData
struct | _wmfXML_FontInfo
## Typedefs
typedef _wmfRGB | wmfRGB
typedef _wmfBMP | wmfBMP
typedef _wmfBrush | wmfBrush
typedef _wmfPen | wmfPen
typedef _wmfFont | wmfFont
typedef _wmfFontData | wmfFontData
typedef _wmfFT_Mapping | wmfFT_Mapping
typedef _wmfFT_CacheEntry | wmfFT_CacheEntry
typedef _wmfColorData | wmfColorData
typedef _wmfGS_FontData | wmfGS_FontData
typedef _wmfGS_FontInfo | wmfGS_FontInfo
typedef _wmfXML_FontData | wmfXML_FontData
typedef _wmfXML_FontInfo | wmfXML_FontInfo
typedef _wmfDC | wmfDC
typedef _wmfFlood_t | wmfFlood_t
typedef _wmfDrawPixel_t | wmfDrawPixel_t
typedef _wmfDrawArc_t | wmfDrawArc_t
typedef _wmfDrawLine_t | wmfDrawLine_t
typedef _wmfPolyLine_t | wmfPolyLine_t
typedef _wmfDrawRectangle_t | wmfDrawRectangle_t
typedef _wmfPolyRectangle_t | wmfPolyRectangle_t
typedef _wmfBMP_Read_t | wmfBMP_Read_t
typedef _wmfBMP_Draw_t | wmfBMP_Draw_t
typedef _wmfROP_Draw_t | wmfROP_Draw_t
typedef _wmfDrawText_t | wmfDrawText_t
typedef _wmfUserData_t | wmfUserData_t
typedef _wmfFunctionReference | wmfFunctionReference
typedef void(* | wmfMap )(wmfAPI *, wmfFont *)
typedef void(* | wmfCharDrawer )(wmfAPI *, wmfDrawText_t *)
## Functions
void | wmf_ipa_bmp_b64 (wmfAPI *, wmfBMP_Draw_t *, wmfStream *)
void | wmf_ipa_bmp_png (wmfAPI *, wmfBMP_Draw_t *, char *)
void | wmf_ipa_bmp_jpg (wmfAPI *, wmfBMP_Draw_t *, char *)
void | wmf_ipa_bmp_eps (wmfAPI *, wmfBMP_Draw_t *, char *)
void | wmf_ipa_bmp_read (wmfAPI *, wmfBMP_Read_t *)
void | wmf_ipa_bmp_free (wmfAPI *, wmfBMP *)
wmfBMP | wmf_ipa_bmp_copy (wmfAPI *, wmfBMP *, unsigned int, unsigned int)
int | wmf_ipa_bmp_color (wmfAPI *, wmfBMP *, wmfRGB *, unsigned int, unsigned int)
void | wmf_ipa_bmp_setcolor (wmfAPI *, wmfBMP *, wmfRGB *, unsigned char, unsigned int, unsigned int)
int | wmf_ipa_bmp_interpolate (wmfAPI *, wmfBMP *, wmfRGB *, float, float)
void | wmf_ipa_font_init (wmfAPI *, wmfAPI_Options *)
void | wmf_ipa_font_map_gs (wmfAPI *, wmfGS_FontData *, char *)
void | wmf_ipa_font_map_xml (wmfAPI *, wmfXML_FontData *, char *)
void | wmf_ipa_font_map_set (wmfAPI *, wmfMap)
void | wmf_ipa_font_map (wmfAPI *, wmfFont *)
void | wmf_ipa_font_dir (wmfAPI *, char *)
float | wmf_ipa_font_stringwidth (wmfAPI *, wmfFont *, char *)
char * | wmf_ipa_font_lookup (wmfAPI *, char *)
void | wmf_ipa_draw_text (wmfAPI *, wmfDrawText_t *, wmfCharDrawer)
void | wmf_ipa_color_init (wmfAPI *)
void | wmf_ipa_color_add (wmfAPI *, wmfRGB *)
unsigned long | wmf_ipa_color_index (wmfAPI *, wmfRGB *)
unsigned long | wmf_ipa_color_count (wmfAPI *)
wmfRGB * | wmf_ipa_color (wmfAPI *, unsigned long)
char * | wmf_ipa_page_format (wmfAPI *, wmf_page_t)
unsigned int | wmf_ipa_page_width (wmfAPI *, wmf_page_t)
unsigned int | wmf_ipa_page_height (wmfAPI *, wmf_page_t)
wmfRGB | wmf_rgb_white (wmfAPI *)
wmfRGB | wmf_rgb_black (wmfAPI *)
wmfRGB | wmf_rgb_color (wmfAPI *, float, float, float)

## Typedef Documentation

typedef struct _wmfBMP wmfBMP

typedef struct _wmfBMP_Draw_t wmfBMP_Draw_t

typedef struct _wmfBMP_Read_t wmfBMP_Read_t

typedef struct _wmfBrush wmfBrush

typedef void (* wmfCharDrawer)(wmfAPI*,wmfDrawText_t*)

typedef struct _wmfColorData wmfColorData

typedef struct _wmfDC wmfDC

typedef struct _wmfDrawArc_t wmfDrawArc_t

typedef struct _wmfDrawLine_t wmfDrawLine_t

typedef struct _wmfDrawPixel_t wmfDrawPixel_t

typedef struct _wmfDrawRectangle_t wmfDrawRectangle_t

typedef struct _wmfDrawText_t wmfDrawText_t

typedef struct _wmfFT_CacheEntry wmfFT_CacheEntry

typedef struct _wmfFT_Mapping wmfFT_Mapping

typedef struct _wmfFlood_t wmfFlood_t

typedef struct _wmfFont wmfFont

typedef struct _wmfFontData wmfFontData

typedef struct _wmfFunctionReference wmfFunctionReference

typedef struct _wmfGS_FontData wmfGS_FontData

typedef struct _wmfGS_FontInfo wmfGS_FontInfo

typedef void (* wmfMap)(wmfAPI*,wmfFont*)

typedef struct _wmfPen wmfPen

typedef struct _wmfPolyLine_t wmfPolyLine_t

typedef struct _wmfPolyRectangle_t wmfPolyRectangle_t

typedef struct _wmfRGB wmfRGB

typedef struct _wmfROP_Draw_t wmfROP_Draw_t

typedef struct _wmfUserData_t wmfUserData_t

typedef struct _wmfXML_FontData wmfXML_FontData

typedef struct _wmfXML_FontInfo wmfXML_FontInfo

## Function Documentation

void wmf_ipa_bmp_b64 | ( | wmfAPI * | API,
|  | wmfBMP_Draw_t * | bmp_draw,
|  | wmfStream * | out
| ) |

int wmf_ipa_bmp_color | ( | wmfAPI * | API,
|  | wmfBMP * | bmp,
|  | wmfRGB * | rgb,
|  | unsigned int | x,
|  | unsigned int | y
| ) |

wmfBMP wmf_ipa_bmp_copy | ( | wmfAPI * | API,
|  | wmfBMP * | bmp,
|  | unsigned int | width,
|  | unsigned int | height
| ) |

void wmf_ipa_bmp_eps | ( | wmfAPI * | API,
|  | wmfBMP_Draw_t * | bmp_draw,
|  | char * | name
| ) |

void wmf_ipa_bmp_free | ( | wmfAPI * | API,
|  | wmfBMP * | bmp
| ) |

int wmf_ipa_bmp_interpolate | ( | wmfAPI * | API,
|  | wmfBMP * | bmp,
|  | wmfRGB * | rgb,
|  | float | x,
|  | float | y
| ) |

void wmf_ipa_bmp_jpg | ( | wmfAPI * | API,
|  | wmfBMP_Draw_t * | bmp_draw,
|  | char * | name
| ) |

void wmf_ipa_bmp_png | ( | wmfAPI * | API,
|  | wmfBMP_Draw_t * | bmp_draw,
|  | char * | name
| ) |

void wmf_ipa_bmp_read | ( | wmfAPI * | API,
|  | wmfBMP_Read_t * | bmp_read
| ) |

void wmf_ipa_bmp_setcolor | ( | wmfAPI * | API,
|  | wmfBMP * | bmp,
|  | wmfRGB * | rgb,
|  | unsigned char | opacity,
|  | unsigned int | x,
|  | unsigned int | y
| ) |

wmfRGB* wmf_ipa_color | ( | wmfAPI * | API,
|  | unsigned long | index
| ) |

void wmf_ipa_color_add | ( | wmfAPI * | API,
|  | wmfRGB * | rgb
| ) |

unsigned long wmf_ipa_color_count | ( | wmfAPI * | API | ) |

unsigned long wmf_ipa_color_index | ( | wmfAPI * | API,
|  | wmfRGB * | rgb
| ) |

void wmf_ipa_color_init | ( | wmfAPI * | API | ) |

void wmf_ipa_draw_text | ( | wmfAPI * | API,
|  | wmfDrawText_t * | draw_text,
|  | wmfCharDrawer | ipa_draw_text
| ) |

void wmf_ipa_font_dir | ( | wmfAPI * | API,
|  | char * | fontdir
| ) |

void wmf_ipa_font_init | ( | wmfAPI * | API,
|  | wmfAPI_Options * | options
| ) |

char* wmf_ipa_font_lookup | ( | wmfAPI * | API,
|  | char * | ps_name
| ) |

void wmf_ipa_font_map | ( | wmfAPI * | API,
|  | wmfFont * | font
| ) |

  | This is the fun bit. Parameters:
  API | the API handle
  font | WMF font object: font's family name, italics flag, and the weight
Other inputs include: a ghostscript-style Fontmap, and up to two XML RedHat-style fontmaps. (These are all parsed earlier.) There are also the fallback 13 standard postscript fonts. And then there is a list of font directories to search for fonts. libwmf requires fonts to have a postscript name, and maintains an internal cache of glyphs path and freetype font face, keyed to postscript font name. Unfortunately, although the XML fontmaps do have font family name, the GS fontmap does not. In the latter, therefore, matching WMF font info to postscript font name is hit-and-miss.

void wmf_ipa_font_map_gs | ( | wmfAPI * | API,
|  | wmfGS_FontData * | FD,
|  | char * | gsfontmap
| ) |

void wmf_ipa_font_map_set | ( | wmfAPI * | API,
|  | wmfMap | map
| ) |

void wmf_ipa_font_map_xml | ( | wmfAPI * | API,
|  | wmfXML_FontData * | FD,
|  | char * | xmlfontmap
| ) |

float wmf_ipa_font_stringwidth | ( | wmfAPI * | API,
|  | wmfFont * | font,
|  | char * | str
| ) |

char* wmf_ipa_page_format | ( | wmfAPI * | API,
|  | wmf_page_t | type
| ) |

unsigned int wmf_ipa_page_height | ( | wmfAPI * | API,
|  | wmf_page_t | type
| ) |

unsigned int wmf_ipa_page_width | ( | wmfAPI * | API,
|  | wmf_page_t | type
| ) |

wmfRGB wmf_rgb_black | ( | wmfAPI * | API | ) |

  | The color black. Parameters:
  API | the API handle
Returns: Returns wmf_black.

wmfRGB wmf_rgb_color | ( | wmfAPI * | API,
|  | float | red,
|  | float | green,
|  | float | blue
| ) |

  | Create a color with specified fractions of red, green and blue. Parameters:
  API | the API handle
  red | fraction (0 to 1 inclusive) of color red
  green | fraction (0 to 1 inclusive) of color green
  blue | fraction (0 to 1 inclusive) of color blue
wmf_rgb_color (API,1,1,1) returns wmf_white. wmf_rgb_color (API,0,0,0) returns wmf_black. Returns: Returns the color.

wmfRGB wmf_rgb_white | ( | wmfAPI * | API | ) |

  | The color white. Parameters:
  API | the API handle
Returns: Returns wmf_white.